code	segment	'code'
	assume	cs:code,ds:code

	org	100h

start:	mov	sp,300h			; move stack pointer
	push	ax			; push address for return to DOS

	mov	bl,30h			; resize memory block
	mov	ah,4ah
	int	21h

	mov	ax,3521h		; get current INT 21h handler
	int	21h
	mov	word ptr old21,bx
	mov	word ptr old21+2,es
	push	cs			; restore ES for EXEC
	pop	es

	mov	dx,offset new21		; install new INT 21h handler
	mov	ax,2521h
	int	21h

	mov	bx,offset parm
	mov	[bx+04h],cs		; set segments in param block
	mov	[bx+08h],cs
	mov	[bx+0ch],cs

	mov	dx,offset prog		; EXEC child process
	mov	ax,4b00h
	int	21h

	lds	dx,old21		; restore old INT 21h handler
	mov	ax,2521h
	int	21h

	ret				; return to DOS

new21:	cmp	ah,6			; direct console input?
	jne	pass
	cmp	dl,0ffh
	jne	pass

	mov	ax,1100h		; check for key
	int	16h			; (note: enables interrupts)
	je	exit

	pushf				; save flags
	cmp	al,0			; older enhanced key?
	je	enh
	cmp	al,0e0h			; newer enhanced key?
	je	enh

	mov	ah,10h			; get non-enhanced key
	int	16h

done:	popf				; restore flags
exit:	mov	ah,6			; restore function
	retf	2			; return, drop flags on stack

enh:	xor	byte ptr cs:[parm],1	; toggle signal flag
	jne	noget
	mov	ah,10h			; get enhanced key
	int	16h
	mov	al,ah			; return enhanced key
	jmp	short done
noget:	mov	al,0			; return enhanced key signal
	jmp	short done
pass:
	db	0eah			; far jump opcode
old21	dd	0			; old INT 21h handler address

prog	db	'PRINCE.EXE'		; program filename
parm	dw	0			; default env seg
tail	dd	80h			; command line tail pointer
fcb1	dd	5ch			; first FCB pointer
fcb2	dd	6ch			; second FCB pointer

code	ends

	end	start
